
let rec intervalle r a b =
  if a > b then r
  else intervalle2 (a::r) (a+1) b

and intervalle2 r a b =
  if a > b then []
  else intervalle (a::r) (a+1) b

let intervalle a b = intervalle [] a b 

let print_step =
  let x = ref true in
    fun () ->
      x := not !x;
      if !x then
	print_char '\\'
      else
	print_char '/';
      print_char '\b';
      flush stdout

      

let _ =
  print_endline "huge allocation...";
  for i = 0 to 2 do
    let x = Array.make (5*1024*1024) 0 in
      for i = 0 to  (5*1024*1024) -1 do
	x.(i) <- i;
	print_step();
      done;
      print_endline "huge allocation checking...";
      Array.iteri (fun i e -> print_step(); assert(i=e))  x;
      print_endline "huge allocation checked...";
  done;
  print_endline "Exit !"

